from pymbolic.mapper import CombineMapper
from pymbolic.primitives import Variable


class INameMapper(CombineMapper):
    def map_subscript(self, e):
        if isinstance(e.index, Variable):
            return frozenset([str(e.index)])
        else:
            return frozenset([str(i) for i in e.index])

    def combine(self, values):
        return frozenset().union(*values)


def get_index_inames(e):
    return INameMapper()(e)
